#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>

#include "defines.h"
#include "config.h"
#include "extern.h"

int check_db_match(char *ipaddr) {

	int loop=1;
	int sockfd=0;
	char *buf;
	char str[256];
	int code=0;
	char type;

	if (!(sockfd=net_connect(config->dbhome?config->dbhome:"localhost", config->dbport))) return ERROR;

	while (!(buf=net_read(sockfd))) {
		usleep(500);
	}
	sscanf(buf, "%i %s", &code, str);
	if (code != 200) {
		fprintf(stderr, "DB Error: %s", buf);
		free(buf);
		return ERROR;
	}

	memset(str, '\0', 256);
	sprintf(str, "C %s\n", ipaddr);
	net_send(sockfd, str);

	while (!(buf=net_read(sockfd))) {
		usleep(500);
	}

	if (*buf=='5') {
		fprintf(stderr, "DB Error: %s", buf);
		free(buf);
		return ERROR;
	}

	sscanf(buf, "%i %s", &code, str);
	if (*buf=='2') {
		fprintf(stdout, "Accepting connection from: %s\n", ipaddr);
	} else {
		fprintf(stdout, "Known Bad host deteched: %s\n", ipaddr);
	}
	free(buf);
	close(sockfd);
	return code;

}

int add_addr(int type, char *ipaddr) {

	int sockfd=0;
	char *buf;
	char str[256];
	char c;
	int code=0;

	if (!(sockfd=net_connect(config->dbhome, config->dbport))) return ERROR;

	while (!(buf=net_read(sockfd))) {
		usleep(500);
	}
	sscanf(buf, "%i %s", &code, str);
	free(buf);
	if (code != 200) {
		fprintf(stderr, "DB Error: %s", buf);
		return ERROR;
	}

	memset(str, '\0', 256);
	sprintf(str, "A %c %s\n", type_char(type), ipaddr);
	net_send(sockfd, str);

	while (!(buf=net_read(sockfd))) {
		usleep(500);
	}
	if (*buf=='5') {
		fprintf(stderr, "DB Error: %s", buf);
		free(buf);
		return ERROR;
	}
	free(buf);

	memset(str, '\0', 256);
	sprintf(str, "Q\n");
	net_send(sockfd, str);

	while (!(buf=net_read(sockfd))) {
		usleep(500);
	}
	free(buf);
	close(sockfd);
}

int type_char(int type) {

	switch(type) {
		case HTTP:
			return 'H';
		case SMTP:
			return 'R';
		case SOCKS:
			return 'S';
		case TRAP:
			return 'T';
		case WHITE:
			return 'W';
		case OKLIST:
			return 'O';
		case RDNS:
			return 'D';
		default:
			return -1;
	}
}

int add_good_addr(char *ipaddr) {

	int sockfd=0;
	char *buf;
	char str[256];
	int code=0;

	if (!(sockfd=net_connect(config->dbhome, config->dbport))) return ERROR;

	while (!(buf=net_read(sockfd))) {
		usleep(500);
	}
	sscanf(buf, "%i %s", &code, str);
	free(buf);
	if (code != 200) {
		fprintf(stderr, "DB Error: %s", buf);
		return ERROR;
	}

	memset(str, '\0', 256);
	sprintf(str, "A O %s\n", ipaddr);
	net_send(sockfd, str);

	while (!(buf=net_read(sockfd))) {
		usleep(500);
	}
	if (*buf=='5') {
		fprintf(stderr, "DB Error: %s", buf);
		free(buf);
		return ERROR;
	}
	free(buf);

	memset(str, '\0', 256);
	sprintf(str, "Q\n");
	net_send(sockfd, str);

	while (!(buf=net_read(sockfd))) {
		usleep(500);
	}
	free(buf);
	close(sockfd);
}
