#define CONFIG_FILE_NAME "/etc/sockchk.conf"
#define FILE_BUF 8192
#define NET_BUFFER 8192
#define NET_TIMEOUT 10
#define NET_READ_TIMEOUT 45
#define NET_DTIMEOUT 10
#define PIPE_TIMEOUT 5
/* this is the time to wait for pipe checks */
#define SLEEP 60
/* this is the maximum number of workers to start */
#define MAX_WORKERS 25
/* Maximum requests to the db at any one time */
#define MAX_REQUESTS 20

#undef DEBUG


#undef DMALLOC

#ifdef DMALLOC
#include "dmalloc.h"
#endif

#define FREE 0
#define CONNECTING 1
#define GO 1
#define BUSY 2
#define OK 3

#define NONE 0
#define CHECK 1
#define ADD 2
#define DEL 3

#define IDLE 0
#define HTTP 1
#define SMTP 2
#define SOCKS 3
#define TRAP 4
#define WHITE 5
#define OKLIST 6
#define DONE 6
#define LOCALLIST 7
#define RDNS 8
#define NOT_FOUND 9

#define ERROR -1
#define NOT_MATCHED 0
#define MATCHED 1
#define BAD 2
#define GOOD 3

/* Server Modes */
#define STANDALONE 0
#define DAEMON 1

/* static port allocation.... */
#define MAX_HTTPPORTS 10
#define MAX_SOCKSPORTS 10

/* Default lock location and name */
#define SEM_LOCK "/tmp/sockchk.lock"

/* db type definitions */
#define LOCALDB 0
#define MYSQL 1
#define BERKELEY 2
#define ORACLE 3
