#include "../extern.h"
#include "mysql.h"
#include <stdio.h>
#include <stdarg.h>

int init_db () {

	mysql_init(&mysql);

}

int connect_db () {

	const char *hostname=DBHOST;
	const char *username=DBUSER;
	const char *password=DBPASS;
	const char *database=DBNAME;
	unsigned int port=3306;
	// const char *unix_socket="/tmp/mysql.sock";
	const char *unix_socket="/var/lib/mysql/mysql.sock";
	unsigned int client_flag=0;

	if (!mysql_real_connect(&mysql, hostname, username, password,
													database, port, unix_socket, client_flag)) {
		fprintf(stderr, "Failed to connect to database: Error: %s\n", mysql_error(&mysql));
	}
}

int disconnect_db () {

	mysql_close(&mysql);

}

int query_db (const char *fmt, ...) {

	int d, ret;
	char c, *p, *s;
	char *t, *str, *memp, *buf;
	char *tmp;
	va_list args;

	buf=(char *)calloc(sizeof(char), 1024);
	tmp=(char *)calloc(sizeof(char), 512);

	va_start(args, fmt);
	memp=str=(char *)strdup(fmt);
	while(*str) {
		t=str;
		if (debug) print_debug(5, "t=%s\n", t);
		t=(char *)strchr(t, '%');
		if (!t) break;
		*t='\0';
		if (str) strcat(buf, str);
		t++;
		str=t;
		*tmp='\0';
		switch(*str++) {
			case '%':
				sprintf(tmp, "%s%%", buf);
				if (debug) print_debug(5, "tmp[.]=%s\n", tmp);
				break;
			case 's':
				s = va_arg(args, char *);
				sprintf(tmp, "%s%s", buf, s);
				if (debug) print_debug(5, "tmp[s]=%s\n", tmp);
				break;
			case 'd':
				d = va_arg(args, int);
				sprintf(tmp, "%s%i", buf, d);
				if (debug) print_debug(5, "tmp[d]=%s\n", tmp);
				break;
			case 'c':
				c = (char) va_arg(args, int);
				sprintf(tmp, "%s%c", buf, c);
				if (debug) print_debug(5, "tmp[c]=%s\n", tmp);
				break;
			case 'p':
				s = va_arg(args, char *);
				sprintf(tmp, "%s%p", buf, s);
				if (debug) print_debug(5, "tmp[p]=%s\n", tmp);
				break;
		}
		if (*tmp) strcpy(buf, tmp);
		if (debug) print_debug(5, "buf=%s\n", buf);
	}
	if (str) strcat(buf, str);
	va_end(args);

	if (debug) print_debug(4, "Querying DB [%s]\n", buf);
	ret=mysql_query(&mysql, buf);
	free(memp);
	free(tmp);
	free(buf);
	return ret;
}
	
int query_result () {

	result=mysql_use_result(&mysql);
	while((row=mysql_fetch_row(result))) {
		// do something
	}
	if (!mysql_eof(result)) {
		fprintf(stderr, "Error: %s\n", mysql_error(&mysql));
	}
}
