#include <sys/file.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>

#include "defines.h"
#include "extern.h"
#include "config.h"

int spin_lock(const char *filename) {

	int fd;

	if (debug) print_debug(5, "Opening Lockfile.\n");
	fd=open(filename, O_CREAT | O_RDWR | O_NONBLOCK, S_IRUSR | S_IWUSR);
	if (fd<0) {
		perror("Error opening lock/semaphore file");
		cleanup();
		exit(1);
	}
	while((lockf(fd, F_TEST, 0)<0)) {
		if (debug) print_debug(5, "Spinning waiting for lock\n");
		sleep(5);
	}
	if (debug) print_debug(5, "Getting Lock.\n");
	lockf(fd, F_LOCK, 0);
	return fd;
}

void release_lock(int fd) {

	if (debug) print_debug(5, "Releasing Lock.\n");
	lockf(fd, F_ULOCK, 0);
	if (debug) print_debug(5, "Closing lockfile.\n");
	close(fd);

}

